/*
    Return the fontlist with the current font at the beginning of list
*/

parse arg cfont

fontlist = getclip(ppuser_fontlist)

if fontlist =  '' then
do
   fontlist = ppm_GetTypeFaceList()
   fontlist = substr(fontlist, pos('0a'x, fontlist) + 1)
   call SetClip(ppuser_fontlist, fontlist)
end

if cfont ~= '' then 
cfont2 = '0a'x || cfont
do
   stringpos = pos(cfont2, fontlist)+1
   if stringpos ~= 0 then
   do
        fontlist = delstr(fontlist, stringpos, length(cfont2))
        fontlist = cfont || '0a'x || fontlist
    end
end

return(fontlist)
