/* This Genie restores the previous size of the grid from a file in ram: if available.
Written by Don Cox   Feb 93 Not public domain but freely usable for non-commercial purposes.*/


signal on error
signal on syntax
address command
call SafeEndEdit.rexx()
call ppm_AutoUpdate(0)
cr="0a"x

trace n
currentunits = ppm_GetUnits()

gsize = ppm_GetGridSize()
xspacing = 1 /* defaults */
yspacing = 1


if exists("ram:gridsize") then do
    call open("infile","ram:gridsize")
    gridsize = readln("infile")
    xspacing = word(gridsize,1)
    yspacing = word(gridsize,2)
    end
call ppm_SaveText("ram:gridsize",gsize)
call ppm_SetGridSize(xspacing,yspacing)


call ppm_SetGrid(1)

call ppm_SetGridSnap(1)

call exit_msg()

end

error:
syntax:
    do
    exit_msg("Genie failed due to error: "errortext(rc))
    end

exit_msg:
    do
    parse arg message
    if message ~= "" then
    call ppm_Inform(1,message)
    call ppm_ClearStatus()
    call ppm_AutoUpdate(1)
    exit
    end

