/* Group all the boxes on the current page. Then you can hold down the shift key and move them all at once, or apply any of the group genies.
Written by Don Cox */

trace n
signal on error
signal on syntax
call ppm_AutoUpdate(0)
cr = "0a"x

address command
call SafeEndEdit.rexx()

call ppm_NewGroup()
call ppm_ShowStatus("Grouping Boxes ...")
thispage = ppm_CurrentPage()
totalboxes = ppm_NumBoxes(thispage)
box = ppm_PageFirstBox(thispage)
do i = 1 to totalboxes
    call ppm_AddToGroup(box)
    box = ppm_PageNextBox(box)
    end

exit_msg("Hold down shift key to move the whole group together")

error:
syntax:
    do
    exit_msg("Genie failed due to error: "errortext(rc))
    end

exit_msg:
    do
    parse arg message
    if message ~= "" then
    call ppm_Inform(1,message,"Resume")
    call ppm_ClearStatus()
    call ppm_AutoUpdate(1)
    exit
    end