/*
@BGreekBoxes  @P@ICopyright Gold Disk Inc. February, 1992

This genie will greek all boxes in a document by type.
*/
cr = '0a'x
address command
call SafeEndEdit.rexx()
first   = ppm_DocFirstPage()
last    = ppm_DocLastPage()

call ppm_AutoUpdate(0)
types = "PDraw Clips"cr"Text"cr"BitMap"cr"Structured Graphics"cr"EPSF"
types = upper(ppm_SelectFromList("Select boxes to Greek", 20, 3, 1, types))
if types = '' then exit_msg()
call ppm_ShowStatus("Working..")

do page = first to last
    box = ppm_PageFirstBox(page)
    do while box ~= 0
        info = upper(word(ppm_GetBoxInfo(box), 1))
        if pos(info, types) ~= 0 then
            call ppm_SetBoxHide(box, 1)
        box = ppm_PageNextBox(box)
    end
end

exit_msg()

exit_msg: procedure
do
    parse arg message
    if message ~= '' then call ppm_Inform(1,message,)
    call ppm_ClearStatus()
    call ppm_AutoUpdate(1)
    exit
end

