/*
*/

parse arg lib, autoupdate

units = pdm_GetUnits()
if units = 3 then call pdm_SetUnits(1)
call setclip(pds_units, units)

if datatype(lib, n) then
do
	priority= 0
	offset	= -30
	if lib = 1 then libname = "rexxsupport.library"
	else if lib = 2 then libname = "gdarexxsupport.library"
	else return(0)
end
else
	libname = lib

if ~show(l, libname) then
	if ~(exists("libs:"libname) & addlib(libname, 0, -30)) then
		return("Please install the "libname" in your libs: directory before running this Genie.!")

if datatype(autoupdate, n) then call pdm_AutoUpdate(autoupdate)
return(1)

